    PROGRAM
    INCLUDE('svapi.inc'),ONCE
    INCLUDE('iQXML.INC','Equates')
    INCLUDE('DynStr.inc'),ONCE
    INCLUDE('ABPRXML.INC'),ONCE
    INCLUDE('dynstrclass.inc'),ONCE
    MAP
      INCLUDE('svapifnc.inc'),ONCE
      INCLUDE('iQXML.INC','Modules')
      MODULE('Windows API')
        C82_MultiByteToWideChar(ULONG CodePage,  | ! code page
                                LONG dwFlags,    | ! character-type options
                                LONG lpMultiByteStr, | ! string to map
                                LONG cbMultiByte,    | ! number of bytes in string
                                LONG lpWideCharStr,  | ! wide-character buffer
                                LONG cchWideChar),   |  size of buffer
                                LONG,PASCAL,RAW,NAME('MultiByteToWideChar')
        C82_WideCharToMultiByte(ULONG CodePage,LONG dwFlags,LONG lpWideCharStr,LONG cchWideChar,LONG lpMultiByteStr,LONG cbMultiByte,LONG lpDefaultChar,BYTE lpUsedDefaultChar),LONG,PASCAL,RAW,NAME('WideCharToMultiByte')
      END
      MODULE('API')
        82_CreateFile(*CSTRING,ULONG,ULONG,ULONG,ULONG,ULONG,UNSIGNED),UNSIGNED,PASCAL,RAW,NAME('CreateFileA')
        82_ReadFile(HANDLE hFile, long lpBuffer, long dwBytes, *long dwBytesRead, long lpOverlapped),bool,raw,pascal,NAME('ReadFile')
        82_WriteFile(HANDLE hFile, long lpBuffer, long dwBytes, *long dwBytesWritten, long lpOverlapped),bool,raw,pascal,proc,NAME('WriteFile')
        82_SetCommState(LONG Handle, *k802_TDCB DCB),BYTE,RAW,PASCAL,NAME('SetCommState')
        82_GetCommState(LONG Handle, *k802_TDCB DCB),BYTE,RAW,PASCAL,NAME('GetCommState')
        82_BuildCommDCB(*CSTRING Mode, *k802_TDCB DCB),BYTE,PASCAL,RAW,NAME('BuildCommDCBA')
        82_PurgeComm(LONG Handle, LONG dwFlags),BYTE,PASCAL,RAW,NAME('PurgeComm')
        82_SetCommTimeouts(LONG Handle, *k802_TCOMMTIMEOUTS COMMTIMEOUTS),BYTE,PASCAL,RAW,NAME('SetCommTimeouts')
        82_GetTempPath(LONG nBufferLength, *CSTRING lpBuffer),SIGNED,PASCAL,RAW,PROC,NAME('GetTempPathA')
      END
    END

GLO:sp802TFile          STRING(256)

sp802TFile              FILE,DRIVER('DOS'),PRE(sp802TFile),CREATE,NAME(GLO:sp802TFile)
Record                    RECORD
Line                        STRING(1)
                          END
                        END

k802_xINVALID_HANDLE_VALUE     EQUATE(-1)
k802_PURGE_TXABORT             EQUATE(1)
k802_PURGE_RXABORT             EQUATE(2)
k802_PURGE_TXCLEAR             EQUATE(4)
k802_PURGE_RXCLEAR             EQUATE(8)

k802_TCOMMTIMEOUTS               GROUP,TYPE
ReadIntervalTimeout           LONG
ReadTotalTimeoutMultiplier    LONG
ReadTotalTimeoutConstant      LONG
WriteTotalTimeoutMultiplier   LONG
WriteTotalTimeoutConstant     LONG
                            END

k802_TDCB                      GROUP,TYPE
DCBlength                   ULONG     ! sizeof(DCB)
BaudRate                    ULONG     ! current baud rate
fBinary                     ULONG(1)  !  binary mode, no EOF check
fParity                     ULONG(1)  !  enable parity checking
fOutxCtsFlow                ULONG(1)  !  CTS output flow control
fOutxDsrFlow                ULONG(1)  !  DSR output flow control
fDtrControl                 ULONG(2)  !  DTR flow control type
fDsrSensitivity             ULONG(1)  !  DSR sensitivity

fTXContinueOnXoff           ULONG(1)  !  XOFF continues Tx
fOutX                       ULONG(1)  !  XON/XOFF out flow control
fInX                        ULONG(1)  !  XON/XOFF in flow control
fErrorChar                  ULONG(1)  !  enable error replacement
fNull                       ULONG(1)  !  enable null stripping
fRtsControl                 ULONG(2)  !  RTS flow control
fAbortOnError               ULONG(1)  !  abort reads/writes on error
fDummy2                     ULONG(17) !  reserved
wReserved                   SIGNED    !  not currently used

XonLim                      SIGNED    !  transmit XON threshold
XoffLim                     SIGNED    !  transmit XOFF threshold

Parity                      BYTE      !  0-4=no,odd,even,mark,space
StopBits                    BYTE      !  0,1,2 = 1, 1.5, 2
XonChar                     BYTE      !  Tx and Rx XON character
XoffChar                    BYTE      !  Tx and Rx XOFF character
ErrorChar                   BYTE      !  error replacement character

EofChar                     BYTE      !  end of input character
EvtChar                     BYTE      !  received event character
wReserved1                  SIGNED    !  reserved  do not use
                          END

!  
K802:NDS:0       EQUATE(3)
K802:NDS:10      EQUATE(2)
K802:NDS:18      EQUATE(1)
K802:NDS:NULL    EQUATE(4)
K802:NDS:18_118  EQUATE(5)
K802:NDS:10_110  EQUATE(6)

!  
K802:DOC:CHK     EQUATE(1)            
K802:DOC:BK_CHK  EQUATE(2)

!    
K802:MOT:IN      EQUATE(1)
K802:MOT:OUT     EQUATE(2)

K802:Header      GROUP,TYPE
DocType            BYTE
AccountStr         STRING(64)
KassirName         STRING(64)
PhoneNumber        STRING(64)
EMail              STRING(64)
Comment            STRING(256)
CashSumm           DECIMAL(20,2)
NonCashSumm        DECIMAL(20,2)
Total              DECIMAL(20,2)
                 END

K802:Goods       QUEUE,TYPE
GoodsName          STRING(40)
Price              DECIMAL(20,2)
Qty                DECIMAL(20,2)
NDS_Type           BYTE
Info               STRING(1024)
                 END

sp802class      CLASS,TYPE
CommPort          CSTRING(10)
PortHandle        LONG
DCB               LIKE(k802_TDCB)
Mode              CSTRING(100)
COMMTIMEOUTS      LIKE(k802_TCOMMTIMEOUTS)
PortOpened        BYTE
GUID              CSTRING(23)
LastCID           BYTE
LoginName         CSTRING(100)
Response          CSTRING(64000)

AddBr             PROCEDURE(STRING T, SHORT L=40),STRING                 !    40     
GetTempFile       PROCEDURE(),STRING                                     !    
GetToken          PROCEDURE(),STRING                                     !     20 
cp1251_UTF8       PROCEDURE(STRING cp1251),STRING                        !  windows-1251  UTF-8
WriteFile         PROCEDURE(STRING FileName, STRING Data)                !   
ReadFile          PROCEDURE(STRING FileName),STRING                      !   
SetKassir         PROCEDURE(STRING T)                                    !   
Error             PROCEDURE(SHORT E),STRING                              !    

Init              PROCEDURE(BYTE PortNumber)                             !  
OpenPort          PROCEDURE(),PROC,BYTE                                  !  
ClosePort         PROCEDURE()                                            !  
WritePort         PROCEDURE(STRING Txt),PROC,BYTE                        !   
ReadPort          PROCEDURE(*IDynStr DS),LONG                            !   

SendCommand       PROCEDURE(LONG ID, <STRING T>),PROC,BYTE              !      WritePort
ReadCommand       PROCEDURE(),PROC,BYTE                                  !    ReadPort   .  SELF.Response = XML 

GetStatus         PROCEDURE()                                            !     
NonFiscalDoc      PROCEDURE(STRING T)                                    !   
Receipt           PROCEDURE(*K802:Header GHeader, *K802:Goods QGoods)    !  
ShiftOpen         PROCEDURE                                              !  
ShiftClose        PROCEDURE                                              !  
PrintXReport      PROCEDURE                                              !   
ShiftCloseZ       PROCEDURE                                              !  Z    
GetDateTime       PROCEDURE(*LONG D, *LONG T),BYTE                       !     
SetDateTime       PROCEDURE(<LONG D>, <LONG T>)                          !     
RePrint           PROCEDURE                                              !   
CashDrawerOpen    PROCEDURE                                              !   
MoneyOperation    PROCEDURE(BYTE MOT=K802:MOT:IN, REAL Summa)            ! /   
FNShortStatus     PROCEDURE(*LONG ShiftState, *LONG ShiftNumber)         !     
                END

sp802           sp802class

!Demo

H               GROUP(K802:Header).
G               QUEUE(K802:Goods).

KDate           LONG
KTime           LONG

l:ShiftState    LONG
l:ShiftNumber   LONG

 CODE
 sp802.Init(1)

 sp802.SetKassir(' . .')

 IF sp802.OpenPort()
   MESSAGE('    |      ','')
 END

 sp802.FNShortStatus(l:ShiftState, l:ShiftNumber)
 !      
 IF l:ShiftState = 0
   sp802.SetDateTime()
   MESSAGE(' |   ')
 END

 IF sp802.GetDateTime(KDate, KTime)
   MESSAGE('   |' & FORMAT(KDate,@D10-)&' '&FORMAT(KTime,@T4))
 END

 sp802.ShiftOpen

 sp802.NonFiscalDoc(' .  ')

 !   
 sp802.MoneyOperation(K802:MOT:IN, 1)

 !   
 sp802.MoneyOperation(K802:MOT:OUT, 1)

 ! 
 H.DocType = K802:DOC:CHK
 H.AccountStr = '  10'
 H.KassirName = ''
 H.PhoneNumber = '+79145411392'
 H.Comment = ''
 H.CashSumm = 1.10
 H.NonCashSumm = 0
 H.Total = 1.10

 G.GoodsName = ' '
 G.Price = 1.10
 G.Qty = 1
 G.NDS_Type = K802:NDS:18
 G.Info = '   '
 ADD(G)

 sp802.Receipt(H, G)

 ! 
 H.DocType = K802:DOC:BK_CHK
 H.AccountStr = '  10'
 H.KassirName = ''
 H.PhoneNumber = '+79145411392'
 H.Comment = ''
 H.CashSumm = 1.10
 H.NonCashSumm = 0
 H.Total = 1.10

 G.GoodsName = ' '
 G.Price = 1.10
 G.Qty = 1
 G.NDS_Type = K802:NDS:18
 G.Info = '   '
 ADD(G)

 sp802.Receipt(H, G)

 sp802.CashDrawerOpen

 sp802.PrintXReport

 sp802.ShiftCloseZ

 !  
 !sp802.ShiftClose
 !sp802.GetStatus()

 sp802.ClosePort()

!-----------------------------   -----------------------------
sp802class.AddBr             PROCEDURE(STRING T, SHORT L=40)!,STRING
DS                           DynStr
LenStr                       SHORT
FromPos                      SHORT
  CODE
  LenStr = LEN(CLIP(T))
  FromPos = 1
  LOOP
    DS.Cat( SUB(T, FromPos, L) & '<13,10>' )
    IF FromPos + L >= LenStr THEN BREAK END
    FromPos += L
  END
  RETURN DS.Str()

sp802class.GetTempFile       PROCEDURE()!,STRING
LOC:Result                   CSTRING(255)
  CODE
  82_GetTempPath(SIZE(LOC:Result), LOC:Result)
  LOC:Result = CLIP(LOC:Result)&SELF.GetToken()
  RETURN LOC:Result

sp802class.GetToken          PROCEDURE()!,STRING
Result                       STRING(20)
  CODE
  LOOP W# = 1 TO 20
    EXECUTE RANDOM(1,3)
      Result[W#] = CHR(RANDOM(48,57))
      Result[W#] = CHR(RANDOM(65,90))
      Result[W#] = CHR(RANDOM(97,122))
    END
  END
  RETURN Result

sp802class.cp1251_UTF8       PROCEDURE(STRING cp1251)!,STRING
loc:cp1251                   CSTRING(10000)
loc:unicode                  CSTRING(20000)
loc:utf8                     CSTRING(40000)
  CODE
  loc:cp1251 = cp1251
  BytesConverted# = C82_MultiByteToWideChar(0, 0, ADDRESS(loc:cp1251), -1, ADDRESS(loc:unicode), 0)
  Err# = C82_MultiByteToWideChar(0, 0, ADDRESS(loc:cp1251), -1, ADDRESS(loc:unicode), BytesConverted#)
  Err# = C82_WideCharToMultiByte(65001, 0, ADDRESS(loc:unicode), BytesConverted#, ADDRESS(loc:utf8), SIZE(loc:utf8), 0, 0)
  RETURN loc:utf8

sp802class.WriteFile         PROCEDURE(STRING FileName, STRING Data)
DataLen                      LONG,AUTO
  CODE
  GLO:sp802TFile = FileName
  CREATE(sp802TFile)
  OPEN(sp802TFile)
  DataLen = LEN(CLIP(Data))
  LOOP W# = 1 TO DataLen
    sp802TFile.Line = Data[W#]
    ADD(sp802TFile)
  END
  CLOSE(sp802TFile)

sp802class.ReadFile          PROCEDURE(STRING FileName)!,STRING
buf                          STRING(64000)
  CODE
  GLO:sp802TFile = FileName
  OPEN(sp802TFile)
  SET(sp802TFile,1)
  Z# = 1
  LOOP
    NEXT(sp802TFile)
    IF ERRORCODE() THEN BREAK END
    buf[Z#] = sp802TFile.Line
    Z# += 1
  END
  CLOSE(sp802TFile)
  RETURN CLIP(buf)

sp802class.SetKassir         PROCEDURE(STRING T)
  CODE
  SELF.LoginName = SELF.cp1251_UTF8(T)

sp802class.Error             PROCEDURE(SHORT E)!,STRING
  CODE
  CASE E
  OF 2
    RETURN '   '
  OF 1001
    RETURN ' '
  OF 1002  
    RETURN '  '
  OF 1003  
    RETURN '      '
  OF 1004  
    RETURN '   /'
  OF 1005  
    RETURN '    '
  OF 1006  
    RETURN '     '
  OF 1007  
    RETURN '    '
  OF 1008  
    RETURN '   RTC'
  OF 2001  
    RETURN '   '
  OF 2002  
    RETURN '    '
  OF 2003  
    RETURN '  COM-   '
  OF 2004  
    RETURN '   '
  OF 2005  
    RETURN '  '
  OF 3001  
    RETURN '   '
  OF 3002  
    RETURN '  '
  OF 3003  
    RETURN '   '
  OF 4001  
    RETURN '     '
  OF 4002  
    RETURN '  / |(        )'
  OF 4003  
    RETURN '   24 '
  OF 4004  
    RETURN '    |(      |   30  .)'
  OF 5001  
    RETURN '  '
  OF 5002  
    RETURN '  '
  OF 5003  
    RETURN '  '
  OF 5004  
    RETURN '  '
  OF 5005  
    RETURN '     '
  OF 5006  
    RETURN '    '
  OF 5007  
    RETURN '     '
  OF 5008  
    RETURN '  '
  OF 5009  

    RETURN '     '
  END
  RETURN ''

sp802class.Init              PROCEDURE(BYTE PortNumber)
  CODE
  SELF.CommPort = 'COM'&PortNumber&'<0>'
  SELF.LoginName = SELF.cp1251_UTF8('')

sp802class.ClosePort         PROCEDURE
  CODE
  IF ~CloseHandle(SELF.PortHandle)
    !MESSAGE('PORT CLOSING ERROR '&SELF.CommPort&'<10>Error code ' & GetLastError())
  END
  SELF.PortOpened = FALSE

sp802class.OpenPort          PROCEDURE()!,PROC,BYTE
  CODE
  SELF.PortHandle = 82_CreateFile(SELF.CommPort, GENERIC_READ+GENERIC_WRITE, 0, 0, OPEN_EXISTING, 0, 0)
  IF SELF.PortHandle = k802_xINVALID_HANDLE_VALUE
    !MESSAGE('Port Opening Error '&SELF.CommPort&'<10>Error code ' & GetLastError())
    RETURN(TRUE)
  END
  RetValue# = 82_GetCommState(SELF.PortHandle, SELF.DCB)
  IF RetValue# >= 0
    SELF.Mode = CLIP(SELF.CommPort)&':115200,N,8,1'
    RetValue# = 82_BuildCommDCB(SELF.Mode, SELF.DCB)
    IF RetValue# >= 0
      RetValue# = 82_SetCommState(SELF.PortHandle, SELF.DCB)
      IF RetValue# >= 0
        RetValue# = 82_PurgeComm(SELF.PortHandle, k802_PURGE_TXABORT+k802_PURGE_RXABORT+k802_PURGE_TXCLEAR+k802_PURGE_RXCLEAR)
        IF RetValue# < 0
          !MESSAGE('PORT SETTING ERROR!','MESSAGE',ICON:Asterisk,BUTTON:Ok,BUTTON:Ok,1)
          RETURN(TRUE)
        ELSE
          SELF.COMMTIMEOUTS.ReadIntervalTimeout        = 10
          SELF.COMMTIMEOUTS.ReadTotalTimeoutConstant   = 10
          SELF.COMMTIMEOUTS.ReadTotalTimeoutMultiplier = 1
          RetValue# = 82_SetCommTimeouts(SELF.PortHandle, SELF.COMMTIMEOUTS)
          IF RetValue# < 0
            !MESSAGE('ERROR ON SET TIMEOUT!','MESSAGE',ICON:Asterisk,BUTTON:Ok,BUTTON:Ok,1)
            RETURN(TRUE)
          END
        END
      ELSE
        !MESSAGE('PORT INIT ERROR!','MESSAGE',ICON:Asterisk,BUTTON:Ok,BUTTON:Ok,1)
        RETURN(TRUE)
      END
    ELSE
      !MESSAGE('DCB BUILD ERROR!','MESSAGE',ICON:Asterisk,BUTTON:Ok,BUTTON:Ok,1)
      RETURN(TRUE)
    END
  ELSE
    !MESSAGE('DCB READ ERROR!','MESSAGE',ICON:Asterisk,BUTTON:Ok,BUTTON:Ok,1)
    RETURN(TRUE)
  END
  SELF.PortOpened = TRUE
  RETURN(FALSE)

sp802class.WritePort         PROCEDURE(STRING Txt)!,PROC,BYTE
Buffer32Write                &CSTRING
BytesWrite                   LONG
  CODE
  IF SELF.PortOpened
    Buffer32Write &= NEW CSTRING(LEN(Txt))
    Buffer32Write = Txt
    IF ~82_WriteFile(SELF.PortHandle, ADDRESS(Buffer32Write), LEN(CLIP(Buffer32Write)), BytesWrite, 0)
      DISPOSE(Buffer32Write)
      RETURN FALSE
    ELSE
      DISPOSE(Buffer32Write)
      RETURN TRUE
    END
    DISPOSE(Buffer32Write)
  END
  RETURN FALSE

sp802class.ReadPort          PROCEDURE(*IDynStr DS)!,LONG
Buffer32Read                 STRING(1024)
BytesRead                    LONG
ReadedBytes                  LONG
BeginClock                   LONG
  CODE
  IF SELF.PortOpened
    LOOP
      Buffer32Read = ''
      BytesRead = 0
      IF ~82_ReadFile(SELF.PortHandle, ADDRESS(Buffer32Read), 1024, BytesRead, 0) THEN BREAK END
      !   
      IF BytesRead = 0 AND ReadedBytes = 0
        IF BeginClock = 0
          BeginClock = CLOCK()
        ELSE
          IF CLOCK() - BeginClock > 500
            BREAK
          END
        END
        CYCLE
      END
      ! --------------------
      IF BytesRead = 0 THEN BREAK END
      DS.Cat(Buffer32Read[1:BytesRead])
      ReadedBytes += BytesRead
    END
  END
  RETURN ReadedBytes

sp802class.SendCommand       PROCEDURE(LONG CID, <STRING T>)!,PROC,BYTE
DS                           &IDynStr
XML                          XMLGenerator
TempFileName                 CSTRING(256)
  CODE
  TempFileName = SELF.GetTempFile()
  SELF.LastCID = CID
  SELF.GUID = '{{'&SELF.GetToken()&'}'
  XML.Init(TempFileName)
  XML.OpenDocument()
  XML.SetEncoding('UTF-8')
  XML.SetUseCRLF(TRUE)
  XML.SetRootTag('ArmRequest')
  XML.AddTag('RequestBody','')
  XML.AddTag('ProtocolLabel','OFDFNARMUKM',FALSE,'RequestBody')
  XML.AddTag('ProtocolVersion','10.3',FALSE,'RequestBody')
  XML.AddTag('RequestId',CLIP(SELF.GUID),FALSE,'RequestBody')
  XML.AddTag('DateTime',FORMAT(TODAY(),@D10-)&' '&FORMAT(CLOCK(),@T4),FALSE,'RequestBody')
  XML.AddTag('Command',CID,FALSE,'RequestBody')
  IF ~OMITTED(3)
    XML.AddTag('RequestData',T,TRUE)
  ELSE
    XML.AddTag('RequestData','')
  END
  XML.SetSupportNameSpaces(True)
  XML.CloseDocument()
  DS &= NewDynStr()
  DS.Cat(sp802.ReadFile(TempFileName))
  REMOVE(TempFileName)
  !                                             !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !sp802.WriteFile('comand-'&CLIP(SELF.LastCID)&'.xml', DS.Str())                                      !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  IF SELF.WritePort(DS.Str())
    DisposeDynStr(DS)
    RETURN TRUE
  END
  DisposeDynStr(DS)
  RETURN FALSE

sp802class.ReadCommand       PROCEDURE()!,PROC,BYTE
DS                           &IDynStr
LOC:Result                   BYTE(FALSE)
Temp                         LIKE(SELF.GUID)
eResult                      CSTRING(10)
eErrorCat                    CSTRING(100)
eErrorCatStr                 CSTRING(100)
eErrorCode                   CSTRING(100)
eErrorDescription            CSTRING(1024)
ErrorStr                     CSTRING(200)
  CODE
  DS &= NewDynStr()
  IF SELF.ReadPort(DS)
    !                                              !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    !sp802.WriteFile('result-'&CLIP(SELF.LastCID)&'.xml', DS.Str())                                    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    XML:SetProgressWindow(-1)
    IF NOT XML:LoadFromString(DS.CStr())
      IF NOT XML:FindNextNode('ArmResponse','ResponseBody','RequestId')
        Err# = XML:ReadCurrentData(Temp)
        IF CLIP(Temp) <> SELF.GUID
          MESSAGE('GUID       !','')
        ELSE
          XML:GotoTop()
          IF NOT XML:FindNextNode('ArmResponse','ResponseBody','Result')
            Err# = XML:ReadCurrentData(eResult)
            IF eResult = 1
              XML:GotoTop()
              IF NOT XML:FindNextNode('ArmResponse','ResponseBody','ErrorCategory')
                Err# = XML:ReadCurrentData(eErrorCat)
                IF eErrorCat > 0
                  !  
                  XML:GotoTop()
                  Err# = XML:FindNextNode('ArmResponse','ResponseBody','ErrorCode')
                  Err# = XML:ReadCurrentData(eErrorCode)
                  XML:GotoTop()
                  Err# = XML:FindNextNode('ArmResponse','ResponseBody','ErrorDescription')
                  Err# = XML:ReadCurrentData(eErrorDescription)
                  EXECUTE eErrorCat
                    eErrorCatStr = ' '
                    eErrorCatStr = ' '
                    eErrorCatStr = '  '
                    eErrorCatStr = ' '
                    eErrorCatStr = ' POS '
                  END
                  ErrorStr = SELF.Error(eErrorCode)
                  MESSAGE(CLIP(eErrorCatStr)&': '&CLIP(eErrorCode)&CHOOSE(CLIP(ErrorStr)<>'','|','')&CLIP(ErrorStr),'')
                END
              END
            ELSE
              XML:GotoTop()
              IF NOT XML:FindNextNode('ArmResponse','ResponseData')
                Err# = XML:ReadCurrentData(SELF.Response)
              END
              LOC:Result = TRUE
            END
          END
        END
      END
    END
    XML:Free()
  END
  DisposeDynStr(DS)
  RETURN LOC:Result

sp802class.GetStatus         PROCEDURE()
  CODE
  IF ~SELF.SendCommand(2)
    RETURN
  END
  IF ~SELF.ReadCommand()
    RETURN
  END
  MESSAGE(SELF.Response,' ')

sp802class.NonFiscalDoc      PROCEDURE(STRING T)
DS                           &IDynStr
XML                          XMLGenerator
TempFileName                 CSTRING(256)
  CODE
  TempFileName = SELF.GetTempFile()
  XML.Init(TempFileName)
  XML.SetForceXMLHeader(FALSE)
  XML.OpenDocument()
  XML.SetEncoding('UTF-8')
  XML.SetUseCRLF(FALSE)
  XML.SetRootTag('ArmNonFiscalDoc')
  XML.AddTag('NonFiscalText',SELF.cp1251_UTF8(sp802.Addbr(T)))
  XML.SetSupportNameSpaces(True)
  XML.CloseDocument()
  DS &= NewDynStr()
  DS.Cat(SELF.ReadFile(TempFileName))
  REMOVE(TempFileName)
  Err# = SELF.SendCommand(30, DS.Str())
  DisposeDynStr(DS)
  IF ~SELF.ReadCommand()
    RETURN
  END

sp802class.Receipt           PROCEDURE(*K802:Header GHeader, *K802:Goods QGoods)
DS                           &IDynStr
XML                          XMLGenerator
TempFileName                 CSTRING(256)
  CODE
  TempFileName = SELF.GetTempFile()
  XML.Init(TempFileName)
  XML.SetForceXMLHeader(FALSE)
  XML.OpenDocument()
  XML.SetEncoding('UTF-8')
  XML.SetUseCRLF(FALSE)
  XML.SetRootTag('ArmReceipt')
  XML.AddTag('UserLoginName',SELF.cp1251_UTF8(GHeader.KassirName))
  XML.AddTag('ReceiptType',Gheader.DocType) 
  XML.AddTag('DateTime',FORMAT(TODAY(),@D10-)&' '&FORMAT(CLOCK(),@T4))
  XML.AddTag('TaxSystem','1')
  XML.AddTag('HeaderText',SELF.cp1251_UTF8(SELF.AddBr(GHeader.AccountStr))) !  
  !  
  XML.AddTag('Items','')
  LOOP W# = 1 TO RECORDS(QGoods)
    GET(QGoods, W#)
    XML.AddTag('ArmReceiptItem','',FALSE,'Items')
    XML.AddTag('ItemArticle','',FALSE,'ArmReceiptItem')
    XML.AddTag('ItemName',SELF.cp1251_UTF8(QGoods.GoodsName),FALSE,'ArmReceiptItem')
    XML.AddTag('Price',QGoods.Price,FALSE,'ArmReceiptItem')
    XML.AddTag('Quantity',QGoods.Qty,FALSE,'ArmReceiptItem')
    XML.AddTag('ItemTotal',QGoods.Price * QGoods.Qty,FALSE,'ArmReceiptItem')
    XML.AddTag('TaxType',QGoods.NDS_Type,FALSE,'ArmReceiptItem')
    XML.AddTag('Tax','0',FALSE,'ArmReceiptItem')
    !  
    XML.AddTag('ItemDiscounts','',FALSE,'ArmReceiptItem') 
      XML.AddTag('ArmDiscount','',FALSE,'ItemDiscounts')
      XML.AddTag('Name','',FALSE,'ArmDiscount')
      XML.AddTag('Value','0',FALSE,'ArmDiscount')
    XML.AddTag('ItemText',SELF.cp1251_UTF8(SELF.AddBr(QGoods.Info)),FALSE,'ArmReceiptItem')
  END
  XML.AddTag('CustomerAddress',SELF.cp1251_UTF8(GHeader.PhoneNumber))
  XML.AddTag('Total',GHeader.Total)
  XML.AddTag('CashSumm',GHeader.CashSumm)
  XML.AddTag('NonCashSumm',GHeader.NonCashSumm)
  XML.AddTag('PosNum','0')
  XML.AddTag('PosShiftNum','0')
  XML.AddTag('PosReceiptNum','0')
  !    
  XML.AddTag('ArmReceiptTax','')
    XML.AddTag('nds18','0',FALSE,'ArmReceiptTax')
    XML.AddTag('nds10','0',FALSE,'ArmReceiptTax')
    XML.AddTag('nds00','0',FALSE,'ArmReceiptTax')
    XML.AddTag('ndsNo','0',FALSE,'ArmReceiptTax')
    XML.AddTag('nds18_118','0',FALSE,'ArmReceiptTax')
    XML.AddTag('nds10_110','0',FALSE,'ArmReceiptTax')
  XML.AddTag('Footer','')
  XML.AddTag('FiscalDocNumber','0')
  XML.AddTag('FiscalSign','0')
  XML.AddTag('ShiftNumber','0')
  XML.AddTag('ReceiptNumber','0')
  XML.SetSupportNameSpaces(True)
  XML.CloseDocument()
  DS &= NewDynStr()
  DS.Cat(SELF.ReadFile(TempFileName))
  REMOVE(TempFileName)
  Err# = SELF.SendCommand(8, DS.Str())
  DisposeDynStr(DS)
  IF ~SELF.ReadCommand()
    RETURN
  END

sp802class.ShiftOpen         PROCEDURE
DS                           &IDynStr
XML                          XMLGenerator
TempFileName                 CSTRING(256)
  CODE
  TempFileName = SELF.GetTempFile()
  XML.Init(TempFileName)
  XML.SetForceXMLHeader(FALSE)
  XML.OpenDocument()
  XML.SetEncoding('UTF-8')
  XML.SetUseCRLF(FALSE)
  XML.SetRootTag('ArmShiftOpen')
  XML.AddTag('FiscalDocNumber','0')
  XML.AddTag('FiscalSign','0')
  XML.AddTag('ShiftNumber','0')
  XML.AddTag('UserLoginName',SELF.LoginName)
  XML.AddTag('DateTime',FORMAT(TODAY(),@D10-)&' '&FORMAT(CLOCK(),@T4))
  XML.SetSupportNameSpaces(True)
  XML.CloseDocument()
  DS &= NewDynStr()
  DS.Cat(SELF.ReadFile(TempFileName))
  REMOVE(TempFileName)
  Err# = SELF.SendCommand(4, DS.Str())
  DisposeDynStr(DS)
  IF ~SELF.ReadCommand()
    RETURN
  END

sp802class.ShiftClose        PROCEDURE
DS                           &IDynStr
XML                          XMLGenerator
TempFileName                 CSTRING(256)
  CODE
  TempFileName = SELF.GetTempFile()
  XML.Init(TempFileName)
  XML.SetForceXMLHeader(FALSE)
  XML.OpenDocument()
  XML.SetEncoding('UTF-8')
  XML.SetUseCRLF(FALSE)
  XML.SetRootTag('ArmShiftClose')
  XML.AddTag('FiscalDocNumber','0')
  XML.AddTag('FiscalSign','0')
  XML.AddTag('ShiftNumber','0')
  XML.AddTag('OFDQueueLegth','0')
  XML.AddTag('OFDfirstQueueDocDateTime','0')
  XML.AddTag('ReceiptsCount','0')
  XML.AddTag('FiscalDocCount','0')
  XML.AddTag('OFDLongWait','0')
  XML.AddTag('FNNeedChange','0')
  XML.AddTag('FNOwerflow','0')
  XML.AddTag('FNExhausted','0')
  XML.AddTag('UserLoginName',SELF.LoginName)
  XML.AddTag('DateTime',FORMAT(TODAY(),@D10-)&' '&FORMAT(CLOCK(),@T4))
  XML.SetSupportNameSpaces(True)
  XML.CloseDocument()
  DS &= NewDynStr()
  DS.Cat(SELF.ReadFile(TempFileName))
  REMOVE(TempFileName)
  Err# = SELF.SendCommand(6, DS.Str())
  DisposeDynStr(DS)
  IF ~SELF.ReadCommand()
    RETURN
  END

sp802class.PrintXReport      PROCEDURE
DS                           &IDynStr
XML                          XMLGenerator
TempFileName                 CSTRING(256)
  CODE
  TempFileName = SELF.GetTempFile()
  XML.Init(TempFileName)
  XML.SetForceXMLHeader(FALSE)
  XML.OpenDocument()
  XML.SetEncoding('UTF-8')
  XML.SetUseCRLF(FALSE)
  XML.SetRootTag('ArmCXReport')
  XML.AddTag('UserLoginName',SELF.LoginName)
  XML.AddTag('DateTime',FORMAT(TODAY(),@D10-)&' '&FORMAT(CLOCK(),@T4))
  XML.AddTag('HeaderReport','')
  XML.AddTag('FooterReport','')
  XML.SetSupportNameSpaces(True)
  XML.CloseDocument()
  DS &= NewDynStr()
  DS.Cat(SELF.ReadFile(TempFileName))
  REMOVE(TempFileName)
  Err# = SELF.SendCommand(46, DS.Str())
  DisposeDynStr(DS)
  IF ~SELF.ReadCommand()
    RETURN
  END

sp802class.ShiftCloseZ       PROCEDURE
DS                           &IDynStr
XML                          XMLGenerator
TempFileName                 CSTRING(256)
  CODE
  TempFileName = SELF.GetTempFile()
  XML.Init(TempFileName)
  XML.SetForceXMLHeader(FALSE)
  XML.OpenDocument()
  XML.SetEncoding('UTF-8')
  XML.SetUseCRLF(FALSE)
  XML.SetRootTag('ArmShiftClose')
  XML.AddTag('FiscalDocNumber','0')
  XML.AddTag('FiscalSign','0')
  XML.AddTag('ShiftNumber','0')
  XML.AddTag('OFDQueueLegth','0')
  XML.AddTag('OFDfirstQueueDocDateTime','0')
  XML.AddTag('ReceiptsCount','0')
  XML.AddTag('FiscalDocCount','0')
  XML.AddTag('OFDLongWait','0')
  XML.AddTag('FNNeedChange','0')
  XML.AddTag('FNOwerflow','0')
  XML.AddTag('FNExhausted','0')
  XML.AddTag('UserLoginName',SELF.LoginName)
  XML.AddTag('DateTime',FORMAT(TODAY(),@D10-)&' '&FORMAT(CLOCK(),@T4))
  XML.AddTag('HeaderReport','')
  XML.AddTag('FooterReport','')
  XML.SetSupportNameSpaces(True)
  XML.CloseDocument()
  DS &= NewDynStr()
  DS.Cat(SELF.ReadFile(TempFileName))
  REMOVE(TempFileName)
  Err# = SELF.SendCommand(42, DS.Str())
  DisposeDynStr(DS)
  IF ~SELF.ReadCommand()
    RETURN
  END

sp802class.GetDateTime       PROCEDURE(*LONG D, *LONG T)!,BYTE
Temp                         CSTRING(100)
LOC:Result                   BYTE(FALSE)
  CODE
  Err# = SELF.SendCommand(22, '')
  IF ~SELF.ReadCommand()
    RETURN LOC:Result
  END
  XML:SetProgressWindow(-1)
  IF NOT XML:LoadFromString(SELF.Response)
    IF NOT XML:FindNextNode('DateTime')
      IF NOT XML:ReadCurrentData(Temp)
        D = DEFORMAT(SUB(Temp,1,10),@D10-)
        T = DEFORMAT(SUB(Temp,12,8),@T4)
        LOC:Result = TRUE
      END
    END
  END
  XML:Free()
  RETURN LOC:Result

sp802class.SetDateTime       PROCEDURE(<LONG D>, <LONG T>)
DS                           &IDynStr
XML                          XMLGenerator
TempFileName                 CSTRING(256)
  CODE
  TempFileName = SELF.GetTempFile()
  XML.Init(TempFileName)
  XML.SetForceXMLHeader(FALSE)
  XML.OpenDocument()
  XML.SetEncoding('UTF-8')
  XML.SetUseCRLF(FALSE)
  XML.SetRootTag('ArmCSetDateTime')
  IF OMITTED(2) OR OMITTED(3)
    XML.AddTag('DateTime',FORMAT(TODAY(),@D10-)&' '&FORMAT(CLOCK(),@T4))
  ELSE
    XML.AddTag('DateTime',FORMAT(D,@D10-)&' '&FORMAT(T,@T4))
  END
  XML.SetSupportNameSpaces(True)
  XML.CloseDocument()
  DS &= NewDynStr()
  DS.Cat(SELF.ReadFile(TempFileName))
  REMOVE(TempFileName)
  Err# = SELF.SendCommand(24, DS.Str())
  DisposeDynStr(DS)
  IF ~SELF.ReadCommand()
    RETURN
  END

sp802class.RePrint           PROCEDURE
  CODE
  Err# = SELF.SendCommand(28, '')
  IF ~SELF.ReadCommand()
    RETURN
  END

sp802class.CashDrawerOpen    PROCEDURE
  CODE
  Err# = SELF.SendCommand(36, '')
  IF ~SELF.ReadCommand()
    RETURN
  END

sp802class.MoneyOperation    PROCEDURE(BYTE MOT=K802:MOT:IN, REAL Summa)
DS                           &IDynStr
XML                          XMLGenerator
TempFileName                 CSTRING(256)
  CODE
  TempFileName = SELF.GetTempFile()
  XML.Init(TempFileName)
  XML.SetForceXMLHeader(FALSE)
  XML.OpenDocument()
  XML.SetEncoding('UTF-8')
  XML.SetUseCRLF(FALSE)
  XML.SetRootTag('ArmMoneyOperation')
  XML.AddTag('UserLoginName',SELF.LoginName)
  XML.AddTag('DateTime',FORMAT(TODAY(),@D10-)&' '&FORMAT(CLOCK(),@T4))
  XML.AddTag('MoneyOperationType',MOT)
  XML.AddTag('HeaderText','')
  XML.AddTag('CashSumm',Summa)
  XML.AddTag('Footer','')
  XML.SetSupportNameSpaces(True)
  XML.CloseDocument()
  DS &= NewDynStr()
  DS.Cat(SELF.ReadFile(TempFileName))
  REMOVE(TempFileName)
  Err# = SELF.SendCommand(38, DS.Str())
  DisposeDynStr(DS)
  IF ~SELF.ReadCommand()
    RETURN
  END

sp802class.FNShortStatus     PROCEDURE(*LONG ShiftState, *LONG ShiftNumber)
Temp                         CSTRING(100)
  CODE
  Err# = SELF.SendCommand(44, '')
  IF ~SELF.ReadCommand()
    RETURN
  END
  XML:SetProgressWindow(-1)
  IF NOT XML:LoadFromString(SELF.Response)
    IF NOT XML:FindNextNode('ShiftState')
      IF NOT XML:ReadCurrentData(Temp)
        ShiftState = Temp
      END
    END
    XML:GotoTop()
    IF NOT XML:FindNextNode('ShiftNumber')
      IF NOT XML:ReadCurrentData(Temp)
        ShiftNumber = Temp
      END
    END
  END
  XML:Free()

